import type { EggCore } from './egg.js';
export type SingletonCreateMethod = (config: Record<string, any>, app: EggCore, clientName: string) => unknown | Promise<unknown>;
export interface SingletonOptions {
    name: string;
    app: EggCore;
    create: SingletonCreateMethod;
}
export declare class Singleton<T = any> {
    #private;
    readonly clients: Map<string, T>;
    readonly app: EggCore;
    readonly create: SingletonCreateMethod;
    readonly name: string;
    readonly options: Record<string, any>;
    constructor(options: SingletonOptions);
    init(): void | Promise<void>;
    initSync(): void;
    initAsync(): Promise<void>;
    /**
     * @deprecated please use `getSingletonInstance(id)` instead
     */
    get(id: string): T;
    /**
     * Get singleton instance by id
     */
    getSingletonInstance(id: string): T;
    createInstance(config: Record<string, any>, clientName: string): T;
    createInstanceAsync(config: Record<string, any>, clientName: string): Promise<T>;
}
